clear all
% Importing DYNRES files
%% Import data from text file.
% Script for importing data from the following text file:
%
%    C:\Marintek\SIMLA\Modeller\Master\30inch Hs1.5 irr
%    tp13\dynpost_stress_1.mpf
%
% To extend the code to different selected data or a different text file,
% generate a function instead of a script.

% Auto-generated by MATLAB on 2013/04/27 16:26:35

% Initialize variables.
filename = 'C:\Marintek\SIMLA\Modeller\Master\16inch Hs1.5 irr tp13\dynpost_stress_1.mpf';
startRow = 9;

% Format string for each line of text:
%   column2: double (%f)
%	column3: double (%f)
% For more information, see the TEXTSCAN documentation.
formatSpec = '%*11s%13f%f%[^\n\r]';

% Open the text file.
fileID = fopen(filename,'r');

% Read columns of data according to format string.
% This call is based on the structure of the file used to generate this
% code. If an error occurs for a different file, try regenerating the code
% from the Import Tool.
dataArray = textscan(fileID, formatSpec, 'Delimiter', '', 'WhiteSpace', '', 'EmptyValue' ,NaN,'HeaderLines' ,startRow-1, 'ReturnOnError', false);

% Close the text file.
fclose(fileID);

% Post processing for unimportable data.
% No unimportable data rules were applied during the import, so no post
% processing code is included. To generate code which works for
% unimportable data, select unimportable cells in a file and regenerate the
% script.

% Create output variable
dynpoststress1 = [dataArray{1:end-1}];
% Clear temporary variables
clearvars filename startRow formatSpec fileID dataArray ans;
%% Stress
s375=dynpoststress1(:,2);

%% RAinflow
t0375=sig2ext(s375);

tp375=round(t0375(3:end));

rf375=rainflow(tp375);

c375=[rf375(3,:),
    rf375(1,:)];

wt=23;
e=1;
SCF=((3*(e-0.1*wt))/wt)+1;

count375=countmember([unique(c375(2,:))],c375(2,:));

C375=(unique(c375(2,:)));

mb375=C375(1,:)*(1-SCF);

sykler375=zeros(109,3);
sykler375(:,2)=2*C375';
sykler375(:,1)=count375';
sykler375(:,3)=2*mb375';

sykler4=sykler375(:,1)*197;
sykler1=zeros(109,3);
sykler1(:,1)=sykler4;
sykler1(:,2)=sykler375(:,2);
sykler1(:,3)=sykler375(:,3);
figure
plot(s375);
xlabel('Time Series [s]')
ylabel('Stress [MPa]')
%% SN - Data %%

% SN curve C DNV-RP-C203

m1=3;         % slope of the curves
m2=5;
Nk=1e7;      % knepunkt
st = 36.84;   % Mpa  , knepunkt
loga1= 10^11.699 ;
loga2= 10^14.832 ;   % Eksempel, se DNV-RP-C203 for korrekte tall
fatlim= 20;   % MPA


%% End SN - Data %%

for n=1:numel(sykler375(:,1));
    if sykler375(n,2) >= st;
         sykler375(n,4)= sykler375(n,2);
         
    elseif  fatlim < sykler375(n,2) < st ;
        sykler375(n,5)=sykler375(n,2);
    end
end

damagem1 = (1/loga1).*sum(sykler375(:,4).*(sykler375(:,1)).^m1);
damagem2 = (1/loga2).*sum(sykler375(:,5).*(sykler375(:,1)).^m2);

damage = damagem1 + damagem2;

Totdamage = sum(sum(damage));